broad24=Font.load("fonts/BROADW.TTF")
broad24:setPixelSizes(24,23)
tiles2 = Image.load("images/boat.png")
portait = Image.createEmpty(54, 54)
tiles = Image.createEmpty(495, 495)
start = Image.createEmpty(36, 54)
lucida25=Font.load("fonts/LCALLIG.TTF")
lucida25:setPixelSizes(25,20)
enemy = Image.createEmpty(18, 18)
life = 1
bonus = Image.createEmpty(58, 58)
white = Color.new(255,255,255)
black = Color.new(0,0,0)
red = Color.new(255,0,0)
screen1 = Image.createEmpty(480, 270)
screen2 = Image.createEmpty(480, 324)
player = Image.createEmpty(36, 36)
playerHeight = 29
playerWidth = 24


map = {
	"hhhhdaaaaaaaaaaaaaaaaghhhh",	
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhfdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghchh",
	"hhhhdaaaaaaaaaaaaaaaagchhh",
	"hhehdaaaaaaaaaaaaaaaaghhhh",
}
map2 = {
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhhhhhhhhhhhhhhhhhhhhhhh",
	"hhhhiiiiiiiiiiiiiiiiiihhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaagbhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhehdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaaghhhh",
	"hhhhdaaaaaaaaaaaaaaaagbhhh",

}


function load_boat ()
for y1=1,2 do
  for x1=1,2 do
     player:blit(((x1-1)*18),((y1-1)*18),tiles,(19*(x1+9))+2+((y1-1)*38),477,18,18)
  end
end
end

function drawTile(tile, x1, y1)
	local tileX = math.mod(tile, 3)
	local tileY = math.floor(tile / 3)
	screen1:blit(6+(18 * x1), (18 * y1), bonus, 19 * tileX + 1, 19 * tileY + 1, 18, 18, false)
end	


function drawTile2(tile, x1, y1)
	local tileX = math.mod(tile, 3)
	local tileY = math.floor(tile / 3)
	screen2:blit(6+(18 * x1), (18 * y1), bonus, 19 * tileX + 1, 19 * tileY + 1, 18, 18, false)
end

function msg (number,number_2)
if currentTime < 3000 then
screen:fontPrint(lucida25,168,85,"Get Ready!", white)

if number == 1 then
screen:fontPrint(broad24,198,159,"Mario", red)
end

screen:blit(127,124,portait)

if number_2 == 0 then
screen:fontPrint(lucida25,162,266,"Mario Boat", black)
end

end
end

function msg2 ()
broad24:setPixelSizes(24,23)
screen:fontPrint(broad24,174,20,"Well Done!", black)
end


function portait_mario ()
for yi=1,3 do
  for xi=1,3 do
     portait:blit(1+((xi-1)*18),1+((yi-1)*18),tiles,19*(xi+8)+1+((yi-1)*57),1,18,18)
  end
end
end

function load_start ()
for yi=1,3 do
  for xi=1,2 do
     start:blit(((xi-1)*18),((yi-1)*18),tiles,(19*(xi-1))+2+((yi-1)*38),78,18,18)
  end
end
end

function draw_screen ()

screen:blit(Player.x,Player.y,player)

if ( currentTime < 1000 ) or ( currentTime > 4000 ) then
      screen:blit(6,6,start,0,0,36,36)
         else
            if currentTime > 3000 then
               screen:blit(6,6,start,0,36,18,18)
screen:blit(24,6,start,18,0,18,18)
screen:blit(6,24,start,18,36,18,18)
screen:blit(24,24,start,18,18,18,18)
screen:blit(34,18,tiles,116,78,6,6)
screen:blit(34,26,tiles,116,78,6,6)
screen:blit(34,34,tiles,116,85,6,6)
                   else
                      if currentTime > 2000 then
  
                         screen:blit(6,6,start,0,0,36,36)
screen:blit(34,18,tiles,116,78,6,6)
screen:blit(34,26,tiles,116,78,6,6)
                             else
                               if currentTime > 1000 then
                                  screen:blit(6,6,start,0,0,36,36)
                                  screen:blit(34,18,tiles,116,78,6,6)
                               end
                    end
          end
    end
end

function movePlayer()
   pad = Controls.read()
   if pad:left() then 
      Player.x = Player.x - 2 
   end

   if pad:right() then 
      Player.x = Player.x + 2 
   end
end

function load_bonus ()
bonus:blit(0,0,tiles,1,476,58,19)
bonus:blit(0,19,tiles,58,476,58,19)
bonus:blit(0,38,tiles,115,476,58,19)
bonus:blit(0,57,tiles,1,476,58,1)
end

function collisionCheck(object)
   if (Player.x + playerWidth > object.x) and (Player.x < object.x + object.width) and (Player.y + playerHeight > object.y) and (Player.y < object.y + object.height) then
      life = life - 1
   end
end

function collisionCheck2(object)
   if (Player.x + playerWidth > object.x) and (Player.x < object.x + object.width) and (Player.y + playerHeight > object.y) and (Player.y < object.y + object.height) then
      Player.x = oldx2
      Player.y = oldy2
   end
end

function mario_boat ()
enemy:blit (0,0,tiles,173,477,18,18)
Player = { x = 236, y = 200 }
Block_A = {}
Block_A[1] = { x = 135, y = 90, height = 18, width = 18  }
Block_A[2] = { x = 190, y = 20, height = 18, width = 18  }
Block_A[3] = { x = 150, y = -100, height = 18, width = 18 }
Block_A[4] = { x = 320, y = -50, height = 18, width = 18 }
Block_A[5] = { x = 225, y = -130, height = 18, width = 18 }
Block_A[6] = { x = 100, y = -185, height = 18, width = 18 }
Block_A[7] = { x = 310, y = -215, height = 18, width = 18 }
Block_A[8] = { x = 200, y = -255, height = 18, width = 18 }
Block_A[9] = { x = 370, y = -300, height = 18, width = 18 }
Block_A[10] = { x = 95, y = -345, height = 18, width = 18 }
Block_A[11] = { x = 290, y = -390, height = 18, width = 18 }
Block_A[12] = { x = 210, y = -425, height = 18, width = 18 }
Block_A[13] = { x = 150, y = -460, height = 18, width = 18 }
Block_A[14] = { x = 320, y = -500, height = 18, width = 18 }
Block_A[15] = { x = 250, y = -545, height = 18, width = 18 }
Block_A[16] = { x = 100, y = -590, height = 18, width = 18 }
Block_A[17] = { x = 310, y = -635, height = 18, width = 18 }
Block_A[18] = { x = 200, y = -685, height = 18, width = 18 }
Block_A[19] = { x = 370, y = -730, height = 18, width = 18 }
Block_A[20] = { x = 95, y = -785, height = 18, width = 18 }
Block_A[21] = { x = 290, y = -830, height = 18, width = 18 }
Block_A[22] = { x = 210, y = -875, height = 18, width = 18 }
Block_A[23] = { x = 310, y = -935, height = 18, width = 18 }
Block_A[31] = { x = 1, y = 1, height = 272, width = 80 }
Block_A[32] = { x = 400, y = 1, height = 272, width = 80 }

minuteur = Timer.new()
minuteur:start()
y = 0
screen1:clear()
screen2:clear()
for zz = 1, 15 do
		line = map[zz]
		for x = 1, 26 do
			tile = string.byte(line, x) - string.byte("a")
			drawTile(tile, x - 1, zz -1)
		end
	end

for zz = 1, 18 do
		line = map2[zz]
		for x = 1, 26 do
			tile = string.byte(line, x) - string.byte("a")
			drawTile2(tile, x - 1, zz -1)
		end
	end

while life > 0 do
 oldx = 236
 oldy = 200
 oldx2 = Player.x
 oldy2 = Player.y
 currentTime = minuteur:time()
 screen:clear()
if y < 541 then
screen:blit(0,y,screen1)
screen:blit(0,y - 270,screen1)
screen:blit(0,y - 540,screen1)
else
screen:blit(0,y - 540,screen1)
screen:blit(0,y - 864,screen2)
end
for a = 1,23 do
  if currentTime > 3000 then
     Block_A[a].y = Block_A[a].y + 1.5
  if currentTime < 17000 then
     y = y + 0.05
  end
 end
end
for a = 1,23 do
screen:blit(Block_A[a].x,Block_A[a].y,enemy)
end
draw_screen ()
   if currentTime > 3000 and currentTime < 17000 then
      movePlayer()
   end

 for n=1,25 do
if n < 24 then
collisionCheck(Block_A[n])
end
if n > 23 then
collisionCheck2(Block_A[n+7])
end
end
 msg (1,0)

if currentTime > 17000 then
msg2 ()
if currentTime > 19500 then
   break
end
end

screen.waitVblankStart()
screen.flip()
end

if life == 1 then
-- win2 ()
dofile ("win.lua")
end

if life == 0 then
-- gameover ()
dofile ("gameover.lua")
end

end

function load_tiles ()
tiles:blit(1,1,tiles2)
end
-- main program
load_tiles ()
load_bonus ()
load_boat ()
portait_mario ()
load_start ()
mario_boat ()
